<template>
  <div class="white-block">
    <p>Для восстановления пароля введите код подтверждения из SMS.</p>
    <div class="row">
      <div class="columns six">
        <label>Код из СМС:</label>
        <input v-model="smsCode"
               autocomplete="off"
               v-validate="'required|length:4'"
               name="код СМС"
               id="sms-code"
               placeholder="Введите код сюда"
               value=""
               v-mask="'####'"
               type="number"
               @keyup.enter="restore"
               :class="getValidateClass('код СМС')"
               ref="sms"
        >
        <validate-message
          v-show="vErrors.has('код СМС')">
          Неверно ввведен код подтверждения.
        </validate-message>
      </div>
    </div>
    <div class="row">
      <div class="columns six">
        <a v-if="callBack" class="refresh">Выслать код повторно через {{backTime}} {{$helpers.plural(backTime, ['секунду', 'секунды', 'секунд'])}}</a>
        <a v-else @click="$emit('methodIsChoosen', {restoreMethod: 'sms'}); tiktak()" class="refresh after-time">Выслать код повторно</a>
      </div>
    </div>
    <div class="row">
      <div class="columns center">
        <button
                :disabled="$interface.buttonLoading"
                :class="{button_loading: $interface.buttonLoading}"
                @click="restore">Восстановить пароль</button>
      </div>
    </div>
  </div>
</template>

<script>
    import ValidateMessage from '@/components/Validators/ValidateMessage'
    import GetValidateClass from '@/mixins/Validation/GetValidateClassMixin'

    export default {
      name: 'SmsCode',
      mixins: [ValidateMessage, GetValidateClass],
      data () {
        return {
          smsCode: '',
          callBack: false,
          backTime: 60,
        }
      },
      methods: {
        restore () {
          this.$validator.validateAll().then((v) => {
            if (v) {
              this.$emit('methodIsChoosen', {restoreMethod: 'sms', smsCode: this.smsCode});
            } else {
              this.$toastr.error('Проверочный код не введен', 'Ошибка');
              this.$helpers.focus();
            }
          }).catch((e) => {
            this.$toastr.error('Проверочный код не введен', 'Ошибка');
            this.$helpers.focus();
          })
        },
        tiktak () {
          if (!this.backTime) {
            this.callBack = false
            this.backTime = 60
            return false
          }

          this.callBack = true
          setTimeout(() => {
            this.backTime--
            this.tiktak()
          }, 1000)
        }
      },
      mounted () {
        this.tiktak();
        this.$store.commit('CALL_WARNING_WINDOW');
        this.$nextTick(() => this.$helpers.focus());
      }
    }
</script>

<style scoped>

</style>
